/* Example of Analog I/O for PCIe-8622

   Author: Reed Lai

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   v 0.0.0 1 Oct 2015 by Winson Chen
     create, blah blah... */

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>

#include "ixpci.h"
#include "_pcie8622_cal.h"

int main(int argc, char **argv)
{
	int fd_dev, i;
	ixpci_reg_t reg;
	ixpci_eep_t eep;
	char *dev_file;
	unsigned int timeout = 0;
	
	dev_file = "/dev/ixpci1";
		/* change this for your device entry */

	/* open device */
	fd_dev = open(dev_file, O_RDWR);
	if (fd_dev < 0) {
		printf("Cannot open device file \"%s.\"\n", dev_file);
		return FAILURE;
	}

        if (ioctl(fd_dev, IXPCI_READ_EEP, &eep)){
		puts("Failure of ioctl command IXPCI_READ_REG: IXPCI_.");
	}

	/*for(i = 0;i < 128; i++)
	{
		printf("0x%x\n",eep.read_eep[i]);
	}*/

	calibration(&eep);


	close(fd_dev);
	return SUCCESS;
}
