/* PCI-180X Libary Function.

   Author: Golden Wang

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   Use vi or gvim to edit this file and set tabstop=4.

   v 0.0.0  11 Jun 2007 by Golde Wang
     function created for PCI-180X DI/O, DA .

*/

#include "pcidio.h"

void *magic_scan(void *);
void *magic_scan_pre_mid_trg(void *);
void *magic_scan_pre_mid_trg_ver_c(void *);
WORD pic_control(WORD, DWORD);
WORD enable_timer0(WORD, DWORD);  // for pacer trigger
WORD disable_timer0(WORD);
WORD enable_timer1(WORD, DWORD );  // for external trigger
WORD disable_timer1(WORD);// timer1 for external trigger
WORD wait_until_pic_ok(WORD fd);

/* extern from pcidio.c */
extern char device_module[LINE_SIZE + 1];
//extern dev_control_t *dev_ctl;

/* declare for pci1800.c */
static WORD wX1Total,wX1Status,wX1Buf[16],wX1Count,wIntTrig,wPreMid;
static WORD wMagicNow[32],wMagicP[32];
static DWORD dwMagicNum,dwMagicN2,dwMagicP[32],dwMagicLowAlarm,dwMagicHighAlarm;
static DWORD dwMagicSum[32];
static WORD wMagicChannel[32],wMagicConfig[32],wMagicAve[32],wMP=0;
static WORD wThreadStatus,wAskThreadStop;
static WORD wMagicScanSave[32],*wMagicScanBuf[32];
static WORD wMagicLowAlarm[32],wMagicHighAlarm[32],wMagicAlarmType[32];
WORD sysconfig = 0;
WORD channel_record;
WORD channel_init = 1;
WORD gain_record;
WORD gain_init = 1;
pthread_t hThread;
pthread_mutex_t lock; /* mutex object */
static WORD wPattern[135000], wM_FUN_INIT=0, wGetAddress=0;
static WORD WDaFrequency;
static float FDaAmplitude;

WORD enable_timer0(WORD fd, DWORD divv)  // for pacer trigger
{
   if (PCIDA_OutputByte(fd, IXPCI_8254CR, 0x34)) return PCIDA_WRITE_8254CR_ERROR;
   if (PCIDA_OutputByte(fd, IXPCI_8254C0, (divv & 0xff))) return PCIDA_WRITE_8254C0_ERROR;
   if (PCIDA_OutputByte(fd, IXPCI_8254C0, ((divv>>8) & 0xff))) return PCIDA_WRITE_8254C0_ERROR;
   return PCIDA_NOERROR;
}

WORD disable_timer0(WORD fd)
{
   if (PCIDA_OutputByte(fd, IXPCI_8254CR, 0x34)) return PCIDA_WRITE_8254CR_ERROR;
   if (PCIDA_OutputByte(fd, IXPCI_8254C0, 0x01)) return PCIDA_WRITE_8254C0_ERROR;
   if (PCIDA_OutputByte(fd, IXPCI_8254C0, 0x00)) return PCIDA_WRITE_8254C0_ERROR;
   return PCIDA_NOERROR;
}

WORD enable_timer1(WORD fd, DWORD divv)  // for external trigger
{
   if (PCIDA_OutputByte(fd, IXPCI_8254CR, 0x34)) return PCIDA_WRITE_8254CR_ERROR;
   if (PCIDA_OutputByte(fd, IXPCI_8254C1, (divv & 0xff))) return PCIDA_WRITE_8254C1_ERROR;
   if (PCIDA_OutputByte(fd, IXPCI_8254C1, ((divv>>8) & 0xff))) return PCIDA_WRITE_8254C1_ERROR;
   return PCIDA_NOERROR;
}

WORD disable_timer1(WORD fd)    // timer1 for external trigger
{
   if (PCIDA_OutputByte(fd, IXPCI_8254CR, 0x34)) return PCIDA_WRITE_8254CR_ERROR;
   if (PCIDA_OutputByte(fd, IXPCI_8254C1, 0x01)) return PCIDA_WRITE_8254C1_ERROR;
   if (PCIDA_OutputByte(fd, IXPCI_8254C1, 0x00)) return PCIDA_WRITE_8254C1_ERROR;
   return PCIDA_NOERROR;
}

WORD pic_control(WORD fd, DWORD i)
{
   WORD j;
   DWORD cr_value = i;
   DWORD sr_value;
//  if (PCIDA_OutputByte(fd, &reg)) return PCIDA_DIGITAL_OUTPUT_ERROR;
  sr_value = PCIDA_InputByte(fd, IXPCI_SR);
  if (sr_value == -1) return PCIDA_READ_SR_ERROR;

  if ((sr_value & 0x04) == 0)
  {
    if (PCIDA_OutputByte(fd, IXPCI_CR, 0xffff)) return PCIDA_WRITE_CR_ERROR;
  }

  j = 0;
  sr_value = PCIDA_InputByte(fd, IXPCI_SR);
  if ( sr_value == FAILURE) return PCIDA_READ_SR_ERROR;
  while ((sr_value & 0x04) == 0)
  {
    j++;
    if (j>32766) return PCIDA_CR_TIME_OUT;
    sr_value = PCIDA_InputByte(fd, IXPCI_SR);
    if ( sr_value == FAILURE) return PCIDA_READ_SR_ERROR;
  }

  cr_value = cr_value & 0xDFFF;
  if (PCIDA_OutputByte(fd, IXPCI_CR, cr_value)) return PCIDA_WRITE_CR_ERROR;

  j = 0;
  sr_value = PCIDA_InputByte(fd, IXPCI_SR);
  if ( sr_value == FAILURE) return PCIDA_READ_SR_ERROR;
  while ((sr_value & 0x04) != 0)
  {
    j++;
    if (j>32766) return PCIDA_CR_TIME_OUT;
    sr_value = PCIDA_InputByte(fd, IXPCI_SR);
    if ( sr_value == FAILURE) return PCIDA_READ_SR_ERROR;
  }

  cr_value = cr_value | 0x2000;
  if (PCIDA_OutputByte(fd, IXPCI_CR, cr_value)) return PCIDA_WRITE_CR_ERROR;

  j = 0;
  sr_value = PCIDA_InputByte(fd, IXPCI_SR);
  if ( sr_value == FAILURE) return PCIDA_READ_SR_ERROR;
  while ((sr_value & 0x04) == 0)
  {
    j++;
    if (j>32766) return PCIDA_CR_TIME_OUT;
    sr_value = PCIDA_InputByte(fd, IXPCI_SR);
    if ( sr_value == FAILURE) return PCIDA_READ_SR_ERROR;
  }

  return PCIDA_NOERROR;
}

// wThreadStatus : 0x01=MagicScan start
//                 0x02=timeout1
//                 0x04=timeout2
//                 0x08=FIFO overflow
//                 0x80=MagicScan OK
//                 0x40=Force to Exit
void *magic_scan(void *arg)
{
  WORD fd = *(WORD *)arg;
  WORD w1,w3;
  DWORD i,dwTime,j,k,dwIndex,wVal;

  // For each channel
  for (j=0; j<wMP; j++) dwMagicSum[j]=0;
  for (j=0; j<wMP; j++) wMagicNow[j]=wMagicAve[j];
  for (j=0; j<wMP; j++) dwMagicP[j]=0;

  pthread_mutex_lock(&lock);
  wThreadStatus = 0x01;
  pthread_mutex_unlock(&lock);

  for (i=0; i<wMP; i++) // For each channel
  {
    dwTime=0;
    for (;;)
    {
      wVal = PCIDA_InputByte(fd, IXPCI_SR);
      if (wVal!=0) break;                       // There has data in the AD FIFO
      dwTime++;
      if ((dwTime>100000) & wIntTrig)
      {
        pthread_mutex_lock(&lock);
        wThreadStatus = 0x02;
        pthread_mutex_unlock(&lock);
        goto ret_label;
      }

      if ( dwTime%1000==999)    // check if the thread need to stop
      {
        pthread_mutex_lock(&lock);
        wVal = wAskThreadStop;
        pthread_mutex_unlock(&lock);
        if (wVal != 0)  // Force to quit this thread
        {
          pthread_mutex_lock(&lock);
          wThreadStatus = 0x40;
          pthread_mutex_unlock(&lock);
          goto ret_label;
        }
      }
    }
        //_inpw(wAddrAdda)&0xffff;
    PCIDA_InputByte(fd, IXPCI_AD);// Remove the AD data from FIFO
  }

  dwMagicLowAlarm=0;
  dwMagicHighAlarm=0;
  for (i=0; i<dwMagicNum; i++)  // Cycles to scan
  {
    for (j=0; j<wMP; j++)       // each channel to scan
    {
      dwTime=0;
      for (;;)
      {
        if (dwTime%1000==1)     // check if the thread need to stop?
        {
          pthread_mutex_lock(&lock);
          wVal=wAskThreadStop;
          pthread_mutex_unlock(&lock);

          if (wVal==0xffff)  // Force to quit this thread  ??Why not wVal!=0??
          {
            pthread_mutex_lock(&lock);
            wThreadStatus=0x40;
            pthread_mutex_unlock(&lock);
            goto ret_label;
          }
        }

        wVal=PCIDA_InputByte(fd, IXPCI_SR)&0x60;        // Read Status Register
        if (wVal==0x20)         // Bit5,6: has data in FIFO and FIFO is full
        {
          pthread_mutex_lock(&lock);
          wThreadStatus=8;
          pthread_mutex_unlock(&lock);
          goto ret_label;
        }

        if (wVal==0x60) break;  // Bit5,6: has data in FIFO and FIFO is not full
        dwTime++;
        if ((dwTime>100000) & wIntTrig)
        {
          pthread_mutex_lock(&lock);
          wThreadStatus=4;
          pthread_mutex_unlock(&lock);
          goto ret_label;
        }
      }

      // Starting digital filter
      dwMagicSum[j]+=PCIDA_InputByte(fd, IXPCI_AD)&0x0fff;      // Get AD data from FIFO
      wMagicNow[j]--;
      w1=wMagicNow[j];
      if (w1==0)        // digital filter
      {
        wVal=(DWORD)(dwMagicSum[j]/wMagicAve[j]);

        if (wMagicScanSave[j]==1)
        {
          *((wMagicScanBuf[j])+dwMagicP[j])=wVal;
          dwMagicP[j]++;  // Modify the buffer pointer offset
        }

        w3=wMagicAlarmType[j];

        if (w3>0)             // 0 = no alarm
        {
          dwIndex=1; k=j;
          while (k>0)
          {
            dwIndex=dwIndex<<1;
            k--;
          }

          if (w3==2)       // 2 = low alarm
          {
            if (wVal<wMagicLowAlarm[j])
            {
              pthread_mutex_lock(&lock);
              dwMagicLowAlarm |= dwIndex;
              pthread_mutex_unlock(&lock);
            }
          }
          else if (w3==1)  // 1 = high alarm
          {
            if (wVal>wMagicHighAlarm[j])
            {
              pthread_mutex_lock(&lock);
              dwMagicHighAlarm |= dwIndex;
              pthread_mutex_unlock(&lock);
            }
          }
          else if (w3==4)  // 4 = high or low  alarm
          {
            if (wVal<wMagicLowAlarm[j])
            {
              pthread_mutex_lock(&lock);
              dwMagicLowAlarm |= dwIndex;
              pthread_mutex_unlock(&lock);
            }

            if (wVal>wMagicHighAlarm[j])
            {
              pthread_mutex_lock(&lock);
              dwMagicHighAlarm |= dwIndex;
              pthread_mutex_unlock(&lock);
            }
          }
          else if (w3==3)  // 3 = in [low,high]  alarm
          {
            if ((wVal>wMagicLowAlarm[j])&& (wVal<wMagicHighAlarm[j]))
            {
              pthread_mutex_lock(&lock);
              dwMagicLowAlarm |= dwIndex;
              dwMagicHighAlarm |= dwIndex;
              pthread_mutex_unlock(&lock);
            }
          }
        }
        dwMagicSum[j]=0;                        // Clear the digital filter
        wMagicNow[j]=wMagicAve[j];      // reset the digital filter numbers
      } // end if(w1            // digital filter
    }   // end  for(j=                  // each channel to scan
  } // end for(i=

  pthread_mutex_lock(&lock);
  wThreadStatus=0x80;    // MagicScan OK
  pthread_mutex_unlock(&lock);

ret_label:
  disable_timer0(fd);
  disable_timer1(fd);
  pthread_exit(0);
}

WORD PCI_180X_DaF_Output(WORD fd, WORD da_channel, float da_value)
{
  DWORD reg_id, reg_value;

  
  if( da_channel == 0 )
  {
    reg_id = IXPCI_DA1;
  }
  else if( da_channel == 1 )
  {
    reg_id = IXPCI_DA2;
  }

  reg_value = (DWORD)(da_value/10.0 * 2048 +2048);

  if (PCIDA_OutputByte(fd, reg_id, reg_value)) return PCIDA_ANALOG_OUTPUT_ERROR;

  return PCIDA_NOERROR;
}

WORD PCI_180X_Da_Output(WORD fd, WORD da_channel, float da_value)
{
  DWORD reg_id, reg_value;

  if( da_channel == 0 )
  {
    reg_id = IXPCI_DA1;
  }
  else if( da_channel == 1 )
  {
    reg_id = IXPCI_DA2;
  }

  reg_value = (DWORD)da_value;

  if (PCIDA_OutputByte(fd, reg_id, reg_value)) return PCIDA_ANALOG_OUTPUT_ERROR;

  return PCIDA_NOERROR;
}

WORD PCI_180X_Digital_Output(WORD fd, DWORD data)
{
  if (PCIDA_OutputByte(fd, IXPCI_DO, data)) return PCIDA_DIGITAL_OUTPUT_ERROR;

  return PCIDA_NOERROR;
}

WORD PCI_180X_Digital_Input(WORD fd, DWORD *di_data)
{
  DWORD reg_value;

  reg_value = PCIDA_InputByte(fd, IXPCI_DI);
  if ( reg_value == FAILURE ) return PCIDA_DIGITAL_INPUT_ERROR;

  *di_data = reg_value;

  return PCIDA_NOERROR;
}

WORD PCI_180X_SetChannelConfig(WORD fd, WORD adchannel, WORD adconfig)
{
   WORD channel;
   DWORD config;
   channel   = adchannel&0x1f;
   sysconfig = adconfig&0x1f;     // store for P180X_AdPolling
   config    = adconfig&0x0f;
   config    = config << 6;
   config += channel;

   /*
   Bit15=1 --> no reset FIFO
   Bit14=?
   Bit13=?
   Bit12=0 --> command [001] --> set channel&Config
   Bit11=0
   Bit10=1
   Bit9 =B --> Range control code [BB] --> unipolar/bipolar & divided by 2
   Bit8 =B
   Bit7 =B --> gain control code [BB]  --> 1/10/100/1000 or 1/2/4/8
   Bit6 =B
   Bit5 =?
   Bit4-Bit0 --> channel number
   */

   config+= 0x8400;      // this is set channel config command
   return( pic_control(fd, config) );
}

WORD PCI_180X_DelayUs(WORD fd, int us)
{
/*
  WORD wDownCount,wLow,wHigh,wVal;
  float   fTimeOut;

  if (us>=8191) return PCIDA_8254_DELAY_ERROR;

   wDownCount=us*8;
   wLow=wDownCount&0xff;
   wHigh=(wDownCount>>8)&0xff;

   if (PCIDA_OutputByte(fd, IXPCI_8254CR, 0xb0)) return PCIDA_WRITE_8254CR_ERROR;
   if (PCIDA_OutputByte(fd, IXPCI_8254C2, wLow)) return PCIDA_WRITE_8254C2_ERROR;
   if (PCIDA_OutputByte(fd, IXPCI_8254C2, wHigh)) return PCIDA_WRITE_8254C2_ERROR; 
  

   fTimeOut=(float)1.0; // wait 1 to stop
   for( ; ; )
   {
     wVal = PCIDA_InputByte(fd, IXPCI_SR);
     wVal = wVal & 0x01;
      if (wVal!=0) break;
      fTimeOut+=(float)1.0;
      if (fTimeOut>6553500.0) return(PCIDA_WRITE_8254C2_ERROR);
   }
*/
   if (ioctl(fd, IXPCI_TIME_SPAN, us))
   {
     printf("Failure of spanning %dus.\n", us);
     close(fd);
     return PCIDA_8254_DELAY_ERROR;
   }
/*
  if (ioctl(fd, IXPCI_TIME_SPAN, us))
  {
     printf("DelayUs ... 1\n");
     close(fd);
     return PCIDA_8254_DELAY_ERROR;
  }
  printf("DelayUs ... 2\n");
*/
  return PCIDA_NOERROR;
}

WORD PCI_180X_AdsPolling(WORD fd, float fAdVal[], WORD index)
{
   WORD      wTime, wZERO;
   DWORD     sr_value, ad_data;
   float     fMAX;
   WORD      i;

   // Clear FIFO
   if (PCIDA_OutputByte(fd, IXPCI_CR, 0x2000)) return PCIDA_WRITE_CR_ERROR;
   if (PCIDA_OutputByte(fd, IXPCI_CR, 0xA000)) return PCIDA_WRITE_CR_ERROR;
   // Sleep(10);

   for (i=0; i<index; i++)
   {
      if (PCIDA_OutputByte(fd, IXPCI_ADST, 0xffff)) return PCIDA_SOFTWARE_TRIGGER_ERROR;	      
      wTime=0;
      for (;;)
      {
         sr_value = PCIDA_InputByte(fd, IXPCI_SR);
         if ( sr_value == FAILURE ) return PCIDA_READ_SR_ERROR;
         sr_value = sr_value & 0x20;
	 if (sr_value!=0) break;
	 wTime++;
	 if (wTime>65530) return PCIDA_CR_TIME_OUT;
      }

      switch (sysconfig)
      {
	 case 0 : wZERO=2048; fMAX=(float)5.0;	break;
	 case 1 : wZERO=2048; fMAX=(float)2.5;	break;
	 case 2 : wZERO=2048; fMAX=(float)1.25; break;
	 case 3 : wZERO=2048; fMAX=(float)0.625; break;
	 case 4 : wZERO=2048; fMAX=(float)10.0; break;
	 case 5 : wZERO=2048; fMAX=(float)5.0;	break;
	 case 6 : wZERO=2048; fMAX=(float)2.5;	break;
	 case 7 : wZERO=2048; fMAX=(float)1.25; break;
	 case 8 : wZERO=   0; fMAX=(float)10.0/2.0; break;  // MAX:4096
	 case 9 : wZERO=   0; fMAX=(float)5.0/2.0;  break;  // MAX:4096
	 case 10: wZERO=   0; fMAX=(float)2.5/2.0;  break;  // MAX:4096
	 case 11: wZERO=   0; fMAX=(float)1.25/2.0; break;  // MAX:4096

	 case 0x10 : wZERO=2048; fMAX=(float)5.0;  break;
	 case 0x11 : wZERO=2048; fMAX=(float)0.5;  break;
	 case 0x12 : wZERO=2048; fMAX=(float)0.05; break;
	 case 0x13 : wZERO=2048; fMAX=(float)0.005; break;
	 case 0x14 : wZERO=2048; fMAX=(float)10.0; break;
	 case 0x15 : wZERO=2048; fMAX=(float)1.0;  break;
	 case 0x16 : wZERO=2048; fMAX=(float)0.1;  break;
	 case 0x17 : wZERO=2048; fMAX=(float)0.01; break;
	 case 0x18 : wZERO=   0; fMAX=(float)(10.0/2.0); break; // MAX:4096
	 case 0x19 : wZERO=   0; fMAX=(float)(1.0/2.0);  break; // MAX:4096
	 case 0x1A : wZERO=   0; fMAX=(float)(0.1/2.0);  break; // MAX:4096
	 case 0x1B : wZERO=   0; fMAX=(float)(0.01/2.0); break; // MAX:4096
      }

      ad_data = PCIDA_InputByte(fd, IXPCI_AD);
      //printf("i = %d ++++ad_data[%d] & 0x0fff : %d\n",i, ad_data,(ad_data&0x0fff));
      if ( ad_data == FAILURE ) return PCIDA_ANALOG_INPUT_ERROR;
      fAdVal[i]=(float)((((float)(ad_data&0x0fff)-wZERO)/2048.0)*fMAX);
      //printf("fAdVal[%d] : %f\n",i,fAdVal[i]);
   }

   return SUCCESS;
}

WORD PCI_1602_AdsPolling(WORD fd, float fAdVal[], WORD index)
{
   WORD      wTime, wZERO;
   DWORD     sr_value;
   short     ad_data;
   float     fMAX;
   WORD      i;

   // Clear FIFO
   if (PCIDA_OutputByte(fd, IXPCI_CR, 0x2000)) return PCIDA_WRITE_CR_ERROR;
   if (PCIDA_OutputByte(fd, IXPCI_CR, 0xA000)) return PCIDA_WRITE_CR_ERROR;
   // Sleep(10);

   for (i=0; i<index; i++)
   {
      if (PCIDA_OutputByte(fd, IXPCI_ADST, 0xffff)) return PCIDA_SOFTWARE_TRIGGER_ERROR;
      wTime=0;
      for (;;)
      {
         sr_value = PCIDA_InputByte(fd, IXPCI_SR);
         if ( sr_value == FAILURE ) return PCIDA_READ_SR_ERROR;
         sr_value = sr_value & 0x20;
         if (sr_value!=0) break;
         wTime++;
         if (wTime>65530) return PCIDA_CR_TIME_OUT;
      }

	switch (sysconfig)
        {
          case 0 : wZERO=2048; fMAX=(float)10.0;  break;
          case 1 : wZERO=2048; fMAX=(float)5.0;   break;
          case 2 : wZERO=2048; fMAX=(float)2.5;   break;
          case 3 : wZERO=2048; fMAX=(float)1.25;  break;
          default: wZERO=2048; fMAX=(float)10.0;  break;
        }

      ad_data = PCIDA_InputByte(fd, IXPCI_AD);
      //printf("i = %d ++++ad_data[%d] & 0x0fff : %d\n",i, ad_data,(ad_data&0x0fff));
      if ( ad_data == FAILURE ) return PCIDA_ANALOG_INPUT_ERROR;
      fAdVal[i]=(float)(ad_data/32768.0F)*fMAX;
      //printf("fAdVal[%d] : %f\n",i,fAdVal[i]);
   }

   return SUCCESS;
}

WORD PCI_180X_AdsPacer(WORD fd, float fAdVal[], WORD index, WORD samplerate)
{
   WORD   wTime,wZERO;
   DWORD  sr_value, ad_data;
   WORD   i;
   float   fMAX;

   //Clear FIFO
   if (PCIDA_OutputByte(fd, IXPCI_CR, 0x2000)) return PCIDA_WRITE_CR_ERROR;
   if (PCIDA_OutputByte(fd, IXPCI_CR, 0xA000)) return PCIDA_WRITE_CR_ERROR;

   enable_timer0(fd, samplerate); // sampling rate=8M/dwSample

   for(i=0; i<index; i++)
   {
      wTime=0;
      for (;;)
      {
	sr_value = PCIDA_InputByte(fd, IXPCI_SR);
        if ( sr_value == FAILURE ) return PCIDA_READ_SR_ERROR;
       	sr_value = sr_value & 0x20;

	if (sr_value!=0) break;
	wTime++;
	if (wTime>65530) return PCIDA_CR_TIME_OUT;
      }

      switch (sysconfig)
      {
	 case 0 : wZERO=2048; fMAX=(float)5.0;	break;
	 case 1 : wZERO=2048; fMAX=(float)2.5;	break;
	 case 2 : wZERO=2048; fMAX=(float)1.25; break;
	 case 3 : wZERO=2048; fMAX=(float)0.625; break;
	 case 4 : wZERO=2048; fMAX=(float)10.0; break;
	 case 5 : wZERO=2048; fMAX=(float)5.0;	break;
	 case 6 : wZERO=2048; fMAX=(float)2.5;	break;
	 case 7 : wZERO=2048; fMAX=(float)1.25; break;
	 case 8 : wZERO=   0; fMAX=(float)10.0/2.0; break;  // MAX:4096
	 case 9 : wZERO=   0; fMAX=(float)5.0/2.0;  break;  // MAX:4096
	 case 10: wZERO=   0; fMAX=(float)2.5/2.0;  break;  // MAX:4096
	 case 11: wZERO=   0; fMAX=(float)1.25/2.0; break;  // MAX:4096

	 case 0x10 : wZERO=2048; fMAX=(float)5.0;  break;
	 case 0x11 : wZERO=2048; fMAX=(float)0.5;  break;
	 case 0x12 : wZERO=2048; fMAX=(float)0.05; break;
	 case 0x13 : wZERO=2048; fMAX=(float)0.005; break;
	 case 0x14 : wZERO=2048; fMAX=(float)10.0; break;
	 case 0x15 : wZERO=2048; fMAX=(float)1.0;  break;
	 case 0x16 : wZERO=2048; fMAX=(float)0.1;  break;
	 case 0x17 : wZERO=2048; fMAX=(float)0.01; break;
	 case 0x18 : wZERO=   0; fMAX=(float)(10.0/2.0); break; // MAX:4096
	 case 0x19 : wZERO=   0; fMAX=(float)(1.0/2.0);  break; // MAX:4096
	 case 0x1A : wZERO=   0; fMAX=(float)(0.1/2.0);  break; // MAX:4096
	 case 0x1B : wZERO=   0; fMAX=(float)(0.01/2.0); break; // MAX:4096
      }

      ad_data = PCIDA_InputByte(fd, IXPCI_AD);
      if ( ad_data == FAILURE ) return PCIDA_ANALOG_INPUT_ERROR;
      fAdVal[i]=(float)((((float)(ad_data&0x0fff)-wZERO)/2048.0)*fMAX);
   }

   return SUCCESS;
}

/* Magic Scan Function */
WORD PCI_180X_AddToScan(WORD fd, WORD wAdChannel, WORD wAdConfig, WORD wAverage, WORD wLowAlarm, WORD wHighAlarm, WORD wAlarmType)
{
   WORD wChannel;
   WORD wConfig;
   WORD rs;

   wMagicLowAlarm[wMP]=wLowAlarm;
   wMagicHighAlarm[wMP]=wHighAlarm;
   wMagicAlarmType[wMP]=wAlarmType;

   wChannel   = (wAdChannel&0x1f);
   wMagicChannel[wMP]=wChannel;
   sysconfig = (wAdConfig&0x1f);     // store for P180X_AdPolling
   wMagicConfig[wMP]=sysconfig;
   wMagicAve[wMP]=wAverage;
   wConfig    = (wAdConfig&0x0f);
   wConfig    = wConfig << 6;
   wConfig   += wChannel;
  
   /*
     Bit15=1 --> no reset FIFO
     Bit14=1
     Bit13=?
     Bit12=1 --> command [100] --> set channel&Config
     Bit11=0
     Bit10=0
     Bit9 =B --> Range control code [BB] --> unipolar/bipolar & divided by 2
     Bit8 =B
     Bit7 =B --> gain control code [BB]  --> 1/10/100/1000 or 1/2/4/8
     Bit6 =B
     Bit5 =?
     Bit4-Bit0 --> channel number
   */

   wConfig+= 0xD000;     // this is set channel config command
   rs = pic_control(fd, wConfig);
   if (rs != PCIDA_NOERROR) return rs;
   wMP++;
   return PCIDA_NOERROR;
}

WORD PCI_180X_SaveScan(WORD fd, WORD wQueueOrder, WORD wBuf[])
{
   if(wQueueOrder>=32) return PCIDA_SET_CHANNEL_ERROR;
   wMagicScanSave[wQueueOrder]=1;
   wMagicScanBuf[wQueueOrder]=wBuf;

   return PCIDA_NOERROR;
}

WORD PCI_180X_ClearScan(WORD fd)
{
   WORD i;

   wMP=0;  // driver pointer
   wThreadStatus=0;
   for (i=0; i<32; i++) wMagicScanSave[i]=0;
   disable_timer0(fd);
   return(pic_control(fd, 0xC000));
}

WORD PCI_180X_StartScan(WORD fd, WORD wSampleRateDiv, WORD wNum, int nPriority)
{
   WORD rs,i,j;
   pthread_attr_t attr;
   struct sched_param param;
   int err;

   wIntTrig=0;  /* is internal trigger */

   dwMagicNum=wNum;
   disable_timer0(fd);
   // create magicscan thread
   rs = pic_control(fd, 0xD400);
   if (rs != PCIDA_NOERROR) return rs;

   //Clear FIFO
   if (PCIDA_OutputByte(fd, IXPCI_CR, 0x2000)) return PCIDA_WRITE_CR_ERROR;
   if (PCIDA_OutputByte(fd, IXPCI_CR, 0xA000)) return PCIDA_WRITE_CR_ERROR;

   enable_timer0(fd, wSampleRateDiv); // Sampling rate=8M/dwSampleRateDiv

   pthread_mutex_init(&lock, NULL); //init mutex object
   pthread_attr_init(&attr);
   bzero(&param, sizeof(param));
   param.__sched_priority = nPriority;
   pthread_attr_setschedparam(&attr, &param);
   wThreadStatus=0;
   err = pthread_create(&hThread, &attr, magic_scan, &fd);

   if (err!=0)
   {
     pthread_mutex_destroy(&lock);
     return PCIDA_CREATE_SCAN_THREAD_ERROR;
   }
   else
   {
     i=0;
     for(;;)
     {
       pthread_mutex_lock(&lock);
       j=wThreadStatus;
       pthread_mutex_unlock(&lock);
       if (j!=0) break;
       i++;
       sleep(1);
       if (i>1000)
       {
         pthread_join(hThread, NULL);
         pthread_mutex_destroy(&lock);
         return PCIDA_MAGIC_SCAN_THREAD_ERROR;
       }
     }
   }

   return PCIDA_NOERROR;
}

void PCI_180X_ReadScanStatus(WORD *wStatus, DWORD *dwLowAlarm, DWORD *dwHighAlarm)
{
   pthread_mutex_lock(&lock);
   *wStatus = wThreadStatus;
   *dwLowAlarm=dwMagicLowAlarm;
   *dwHighAlarm=dwMagicHighAlarm;
   pthread_mutex_unlock(&lock);
   return ;
}

WORD PCI_180X_StopMagicScan(WORD fd)
{
   WORD  i;

   disable_timer0(fd);
   disable_timer1(fd);

   // disable all external trigger
   if (PCIDA_OutputByte(fd, IXPCI_CR, 0xf000)) return PCIDA_WRITE_CR_ERROR;

   pthread_mutex_lock(&lock);
   wAskThreadStop=1;
   pthread_mutex_unlock(&lock);

   for (i=0; i<1000; i++)
   {
     sleep(10);
     pthread_mutex_lock(&lock);
     if (wThreadStatus>1) goto ret_ok;
     pthread_mutex_unlock(&lock);
   }

   return PCIDA_MAGIC_SCAN_THREAD_ERROR;

ret_ok:
   pthread_join(hThread, NULL);
   pthread_mutex_destroy(&lock);

   return PCIDA_NOERROR;
}

/* M_FUNCTION */
WORD P180X_M_FUN_1(WORD fd, WORD wDaFrequency, WORD wDaWave, float fDaAmplitude, WORD wAdClock, WORD wAdNumber, WORD wAdConfig, float fAdBuf[], float fLowAlarm, float fHighAlarm)
{
   float  f1,f2;
   DWORD  dwTime,dwVal,ad_data;
   WORD   i,j,ii,wZERO,wRetVal,wConfig;
   WORD   wData,wI,wJ;
   float  fVal,fMAX,fAdMin,fAdMax;
   float  pi2,ff;

   wRetVal=0;

   wM_FUN_INIT=1;

   if (PCIDA_OutputByte(fd, IXPCI_CR, 0xffff)) return PCIDA_WRITE_CR_ERROR;
   dwVal=wait_until_pic_ok(fd); /* wait until pic ok */
   if(dwVal!=0) { wRetVal = PCIDA_CR_TIME_OUT; goto ret_label; }
   dwVal=pic_control(fd, 0xc000); /* force pic go to power-on state */
   if (dwVal!=0) { wRetVal=PCIDA_WRITE_CR_ERROR; goto ret_label; }

   if (wDaFrequency!=WDaFrequency) goto compute_start;
   if (fDaAmplitude!=FDaAmplitude) goto compute_start;
   goto compute_end;

 compute_start:
   pi2=(float)(3.1415926535*2.0)/(float) wDaFrequency;
   ff=(float)((fDaAmplitude/10.0)*2047.0);
   f1=(float)0.0;
   for (wI=0; wI<wDaFrequency; wI++)  // prepare for digit for D/A
   {
       f2=(float)sin(f1);
       if (f2>=0.0)
       {
	  j=(int)((f2/1.0)*ff);
	  j=0x800+j;  // 0x800=2048
       }
       else
       {
	  j=(int)((f2/(-1.0)*ff));
	  j=0x800-j;  // 0x800=2048
       }
       f1+=pi2;
       wPattern[wI]=j;
   }

   WDaFrequency=wDaFrequency;
   FDaAmplitude=fDaAmplitude;
 compute_end:

   disable_timer0(fd);
   disable_timer1(fd);

   if (PCIDA_OutputByte(fd, IXPCI_CR, 0x6000)) return PCIDA_WRITE_CR_ERROR;
   if (PCIDA_OutputByte(fd, IXPCI_CR, 0xE000)) return PCIDA_WRITE_CR_ERROR;

   wConfig=  wAdConfig;
  
   wConfig&= 0x1f;
   wConfig=  wConfig << 6;
   wConfig+= 0x8400;
   dwVal=pic_control(fd, wConfig); //1010 0100 0000 0000-->load chan_1,PGA=1
   if (dwVal!=0) {wRetVal=PCIDA_WRITE_CR_ERROR; goto ret_label;}

   enable_timer0(fd, wAdClock); // --> start AD --> 330K
   for (wI=0; wI<wDaWave; wI++)
   {
     for (wJ=0; wJ<wDaFrequency; wJ++)
     {
       wData=wPattern[wJ];

       //output analog from DA1
       if (PCIDA_OutputByte(fd, IXPCI_DA1, wData)) return PCIDA_ANALOG_OUTPUT_ERROR;
     }
   }

   wData=wPattern[0];     // return to start
   if (PCIDA_OutputByte(fd, IXPCI_DA1, wData)) return PCIDA_ANALOG_OUTPUT_ERROR;

   disable_timer0(fd); // --> stop AD

   switch (wAdConfig)
   {
       case 0 : wZERO=2048;  fMAX=(float)5.0;  break;
       case 1 : wZERO=2048;  fMAX=(float)2.5;  break;
       case 2 : wZERO=2048;  fMAX=(float)1.25; break;
       case 3 : wZERO=2048;  fMAX=(float)0.625; break;
       case 4 : wZERO=2048;  fMAX=(float)10.0; break;
       case 5 : wZERO=2048;  fMAX=(float)5.0;  break;
       case 6 : wZERO=2048;  fMAX=(float)2.5;  break;
       case 7 : wZERO=2048;  fMAX=(float)1.25; break;
       case 8 : wZERO=	 0;  fMAX=(float)10.0/2.0; break; // MAX:4096
       case 9 : wZERO=	 0;  fMAX=(float)5.0/2.0;  break; // MAX:4096
       case 10: wZERO=	 0;  fMAX=(float)2.5/2.0;  break; // MAX:4096
       case 11: wZERO=	 0;  fMAX=(float)1.25/2.0; break; // MAX:4096

       case 0x10 : wZERO=2048;	fMAX=(float)5.0;  break;
       case 0x11 : wZERO=2048;	fMAX=(float)0.5;  break;
       case 0x12 : wZERO=2048;	fMAX=(float)0.05; break;
       case 0x13 : wZERO=2048;	fMAX=(float)0.005; break;
       case 0x14 : wZERO=2048;	fMAX=(float)10.0; break;
       case 0x15 : wZERO=2048;	fMAX=(float)1.0;  break;
       case 0x16 : wZERO=2048;	fMAX=(float)0.1;  break;
       case 0x17 : wZERO=2048;	fMAX=(float)0.01; break;
       case 0x18 : wZERO=   0;	fMAX=(float)(10.0/2.0); break; // MAX:4096
       case 0x19 : wZERO=   0;	fMAX=(float)(1.0/2.0);  break; // MAX:4096
       case 0x1A : wZERO=   0;	fMAX=(float)(0.1/2.0);  break; // MAX:4096
       case 0x1B : wZERO=   0;	fMAX=(float)(0.01/2.0); break; // MAX:4096
       default: wRetVal=PCIDA_CONFIG_CODE_ERROR; goto ret_label;
   }

   // delay for settling time
   for (i=0; i<5; i++)
   {
     dwTime=0;
     for (;;)
     {
        dwVal = PCIDA_InputByte(fd, IXPCI_SR);
        if ( dwVal == FAILURE ) return PCIDA_READ_SR_ERROR;
        dwVal = dwVal & 0x20;
        
	if (dwVal!=0) break;
	dwTime++;
	if (dwTime>100000) { return( PCIDA_CR_TIME_OUT); }
     }
     
     PCIDA_InputByte(fd, IXPCI_AD);
     //_inpw(wAddrAdda);
   }


   fAdMin=(float)10.0;
   fAdMax=(float)-10.0;
   ii=(WORD)(wAdNumber/2.0);
   for (i=0; i<wAdNumber; i++)
   {
     ad_data = PCIDA_InputByte(fd, IXPCI_AD);
     if ( ad_data == FAILURE ) return PCIDA_ANALOG_INPUT_ERROR;
     fVal=(float)((((float)(ad_data&0x0fff)-wZERO)/(float)2048.0)*fMAX);
     if (fVal<fAdMin) fAdMin=fVal;
     if (fVal>fAdMax) fAdMax=fVal;
     fAdBuf[i]=fVal;
   }


   ret_label:
   if (fAdMin<fLowAlarm)  wRetVal=PCIDA_LOW_ALARM;
   if (fAdMax>fHighAlarm) wRetVal=PCIDA_HIGH_ALARM;
   return( wRetVal );
}

WORD PCI_180X_M_FUN_2(WORD fd, WORD wDaNumber, WORD wDaWave, WORD wDaBuf[], WORD wAdClock, WORD wAdNumber, WORD wAdConfig, WORD wAdBuf[])
{
   DWORD dwTime,dwVal, ad_data;
   WORD i,wConfig,wRetVal,wData,wI,wJ;

   wM_FUN_INIT=1;

   if (PCIDA_OutputByte(fd, IXPCI_CR, 0xffff)) return PCIDA_WRITE_CR_ERROR;
   dwVal=wait_until_pic_ok(fd); /* wait until pic ok */
   if(dwVal!=0) { wRetVal = PCIDA_CR_TIME_OUT; goto ret_label; }
   dwVal=pic_control(fd, 0xc000); /* force pic go to power-on state */
   if (dwVal!=0) { wRetVal=PCIDA_WRITE_CR_ERROR; goto ret_label; }

   for(wI=0; wI<wDaNumber; wI++)
   {
      wPattern[wI]=wDaBuf[wI];
   }

   disable_timer0(fd);
   disable_timer1(fd);

   if (PCIDA_OutputByte(fd, IXPCI_CR, 0x6000)) return PCIDA_WRITE_CR_ERROR;
   if (PCIDA_OutputByte(fd, IXPCI_CR, 0xE000)) return PCIDA_WRITE_CR_ERROR;

   wConfig=wAdConfig;
   wConfig&= 0x1f;
   wConfig=  wConfig << 6;
   wConfig+= 0x8400;
   dwVal=pic_control(fd, wConfig); //1010 0100 0000 0000-->load chan_1,PGA=1
   if (dwVal!=0) {wRetVal=PCIDA_WRITE_CR_ERROR; goto ret_label;}

   enable_timer0(fd, wAdClock ); // --> start AD --> 330K
   for (wI=0; wI<wDaWave; wI++)
   {
     for (wJ=0; wJ<wDaNumber; wJ++)
     {
       wData=wPattern[wJ];
       if (PCIDA_OutputByte(fd, IXPCI_DA1, wData)) return PCIDA_ANALOG_OUTPUT_ERROR;
     }
   }

   wData=wPattern[0];     // return to start
   if (PCIDA_OutputByte(fd, IXPCI_DA1, wData)) return PCIDA_ANALOG_OUTPUT_ERROR;

   disable_timer0(fd); // --> stop AD

   // delay for settling time
   for (i=0; i<5; i++)
   {
     dwTime=0;
     for (;;)
     {
	dwVal = PCIDA_InputByte(fd, IXPCI_SR);
        if ( dwVal == FAILURE ) return PCIDA_READ_SR_ERROR;
        dwVal = dwVal & 0x20;

        if (dwVal!=0) break;

	dwTime++;
	if (dwTime>100000) { return( PCIDA_CR_TIME_OUT ); }
     }

     PCIDA_InputByte(fd, IXPCI_AD); // Remove AD data from FIFO
   }

   for (wI=0; wI<wAdNumber; wI++)
   {
      ad_data = PCIDA_InputByte(fd, IXPCI_AD);
      if ( ad_data == FAILURE ) return PCIDA_ANALOG_INPUT_ERROR;
      wAdBuf[wI]=ad_data&0x0fff;
   }

  ret_label:
  return ;
}

WORD PCI_180X_M_FUN_3(WORD fd, WORD wDaFrequency, WORD wDaWave, float fDaAmplitude, WORD wAdClock, WORD wAdNumber, WORD  wChannelStatus[], WORD wAdConfig[], float fAdBuf[], float fLowAlarm, float fHighAlarm)
{
   float  f1,f2;
   DWORD  dwTime,dwIndex, dwVal, dwData, ad_data;
   WORD   i,j,wZERO,wRetVal,wConfig;
   WORD   wTotalCh,wI,wJ;
   double ff;
   float  pi2,fVal,fAdMin,fAdMax,fMAX;
   struct ChannelParameter_Tag
   {
      WORD     wZERO;
      float    fMAX;
   } ChannelParameter[32];

   wRetVal=0;

   wTotalCh=0;
   wM_FUN_INIT=1;

   // STEP_1 : clear_scan_first
   disable_timer0(fd);
   dwVal=pic_control(fd, 0xC000); /* 11?0 00?? ???? ???? cmd_000=reset */
   if(dwVal!=0) return(dwVal);

   // STEP_2 : add_to_scan
   wTotalCh=0;
   for(i=0; i<32; i++)
   {
     if(wChannelStatus[i]!=0)
     {
       switch (wAdConfig[i])
       {
         case 0 : wZERO=2048; fMAX=(float)5.0;	break;
	 case 1 : wZERO=2048; fMAX=(float)2.5;	break;
	 case 2 : wZERO=2048; fMAX=(float)1.25; break;
	 case 3 : wZERO=2048; fMAX=(float)0.625; break;
	 case 4 : wZERO=2048; fMAX=(float)10.0; break;
	 case 5 : wZERO=2048; fMAX=(float)5.0;	break;
	 case 6 : wZERO=2048; fMAX=(float)2.5;	break;
	 case 7 : wZERO=2048; fMAX=(float)1.25; break;
	 case 8 : wZERO=   0; fMAX=(float)10.0/2.0; break; // MAX:4096
	 case 9 : wZERO=   0; fMAX=(float)5.0/2.0;  break; // MAX:4096
	 case 10: wZERO=   0; fMAX=(float)2.5/2.0;  break; // MAX:4096
	 case 11: wZERO=   0; fMAX=(float)1.25/2.0; break; // MAX:4096

	 case 0x10 : wZERO=2048; fMAX=(float)5.0;  break;
	 case 0x11 : wZERO=2048; fMAX=(float)0.5;  break;
	 case 0x12 : wZERO=2048; fMAX=(float)0.05; break;
	 case 0x13 : wZERO=2048; fMAX=(float)0.005; break;
	 case 0x14 : wZERO=2048; fMAX=(float)10.0; break;
	 case 0x15 : wZERO=2048; fMAX=(float)1.0;  break;
	 case 0x16 : wZERO=2048; fMAX=(float)0.1;  break;
	 case 0x17 : wZERO=2048; fMAX=(float)0.01; break;
	 case 0x18 : wZERO=   0; fMAX=(float)(10.0/2.0); break; // MAX:4096
	 case 0x19 : wZERO=   0; fMAX=(float)(1.0/2.0);  break; // MAX:4096
	 case 0x1A : wZERO=   0; fMAX=(float)(0.1/2.0);  break; // MAX:4096
	 case 0x1B : wZERO=   0; fMAX=(float)(0.01/2.0); break; // MAX:4096
	 default: wRetVal=PCIDA_CONFIG_CODE_ERROR;   return(wRetVal);
       }

       ChannelParameter[wTotalCh].wZERO=wZERO;
       ChannelParameter[wTotalCh].fMAX=fMAX;

       wConfig	= wAdConfig[i]&0x0f;
       wConfig	= wConfig << 6;
       wConfig   += i;

       wConfig+= 0xD000;	   // this is set channel config command
       dwVal=pic_control(fd, wConfig);
       if(dwVal!=0) return(dwVal);
       wTotalCh++;
     }
   }

   if (wDaFrequency!=WDaFrequency) goto compute_start;
   if (fDaAmplitude!=FDaAmplitude) goto compute_start;
   goto compute_end;

 compute_start:
   pi2=(float)(3.1415926535*2.0)/wDaFrequency;
   ff=(fDaAmplitude/10.0)*2047.0;
   f1=(float)0.0;
   for(wI=0; wI<wDaFrequency; wI++)  // prepare for digit for D/A
   {
       f2=(float)sin(f1);
       if (f2>=0)
       {
	  j=(int)((f2/1.0)*ff);
	  j=0x800+j;  // 0x800=2048
       }
       else
       {
	  j=(int)((f2/(-1.0)*ff));
	  j=0x800-j;  // 0x800=2048
       }
       f1+=pi2;
       wPattern[wI]=j;
   }

   WDaFrequency=wDaFrequency;
   FDaAmplitude=fDaAmplitude;
 compute_end:

   disable_timer0(fd);
   disable_timer1(fd);


   // STEP_3 : start_to_scan

   dwVal=pic_control(fd, 0xD400); /* 11?1 01?? ???? ???? cmd_101=start scan */
   if (dwVal!=0) return(dwVal);

   // Clear FIFO
   if (PCIDA_OutputByte(fd, IXPCI_CR, 0x2000)) return PCIDA_WRITE_CR_ERROR;
   if (PCIDA_OutputByte(fd, IXPCI_CR, 0xA000)) return PCIDA_WRITE_CR_ERROR;

   //wConfig=  wAdConfig;

   enable_timer0(fd, wAdClock); // --> start AD --> 330K
   for(wI=0; wI<wDaWave; wI++)
   {
     for(wJ=0; wJ<wDaFrequency; wJ++)
     {
       dwData=wPattern[wJ];
       if (PCIDA_OutputByte(fd, IXPCI_DA1, dwData)) return PCIDA_ANALOG_OUTPUT_ERROR;
     }
   }

   dwData=wPattern[0];     // return to start
   if (PCIDA_OutputByte(fd, IXPCI_DA1, dwData)) return PCIDA_ANALOG_OUTPUT_ERROR;

   disable_timer0(fd); // --> stop AD

   // delay for settling time
   for (i=0; i<wTotalCh; i++)
   {
     dwTime=0;
     for (;;)
     {
        dwVal = PCIDA_InputByte(fd, IXPCI_SR);
        if ( dwVal == FAILURE ) return PCIDA_READ_SR_ERROR;
        dwVal = dwVal & 0x20;

        if (dwVal!=0) break;

        dwTime++;
        if (dwTime>100000) { return( PCIDA_CR_TIME_OUT ); }
     }
     //_inpw(wAddrAdda)&0xffff;
     PCIDA_InputByte(fd, IXPCI_AD);
   }

   fAdMin=(float)10.0;
   fAdMax=(float)-10.0;
   for (i=0; i<wAdNumber; i++)
   {
       for(j=0,dwIndex=0; j<wTotalCh; j++,dwIndex+=(DWORD)wAdNumber)
       {
	  ad_data = PCIDA_InputByte(fd, IXPCI_AD);
          if ( ad_data == FAILURE ) return PCIDA_ANALOG_INPUT_ERROR;
	  fVal=(float)((((float)(ad_data&0x0fff)-ChannelParameter[j].wZERO)/2048.0)*ChannelParameter[j].fMAX);
	  if(fVal<fAdMin) fAdMin=fVal;
	  if(fVal>fAdMax) fAdMax=fVal;
	 // dfAdBuf[j*dwAdNumber+i]=dfVal;
	  fAdBuf[dwIndex+i]=fVal;
       }
   }

   if(fAdMin<fLowAlarm)  wRetVal=PCIDA_LOW_ALARM;
   if(fAdMax>fHighAlarm) wRetVal=PCIDA_HIGH_ALARM;
   return(wRetVal);
}

WORD PCI_180X_M_FUN_4(WORD fd, WORD wType, WORD wDaFrequency, WORD wDaWave, float fDaAmplitude, WORD wAdClock, WORD wAdNumber, WORD wChannelStatus[], WORD wAdConfig[], float fAdBuf[], float fLowAlarm, float fHighAlarm)
{
   float  f1,f2;
   DWORD  dwTime,dwIndex, dwVal, dwData, ad_data;
   WORD   i,j,wZERO,wRetVal,wConfig;
   WORD   wTotalCh,wI,wJ;
   double ff;
   float  pi2,fVal,fAdMin,fAdMax,fMAX;
   struct ChannelParameter_Tag
   {
      WORD     wZERO;
      float    fMAX;
   } ChannelParameter[32];

   wRetVal=0;
   wTotalCh=0;
   wM_FUN_INIT=1;

   // STEP_1 : clear_scan_first
   disable_timer0(fd);
   dwVal=pic_control(fd, 0xC000); /* 11?0 00?? ???? ???? cmd_000=reset */
   if(dwVal!=0) return(dwVal);

   // STEP_2 : add_to_scan
   wTotalCh=0;
   for(i=0; i<32; i++)
   {
     if(wChannelStatus[i]!=0)
     {
       switch (wAdConfig[i])
       {
	 case 0 : wZERO=2048; fMAX=(float)5.0;	break;
	 case 1 : wZERO=2048; fMAX=(float)2.5;	break;
	 case 2 : wZERO=2048; fMAX=(float)1.25; break;
	 case 3 : wZERO=2048; fMAX=(float)0.625; break;
	 case 4 : wZERO=2048; fMAX=(float)10.0; break;
	 case 5 : wZERO=2048; fMAX=(float)5.0;	break;
	 case 6 : wZERO=2048; fMAX=(float)2.5;	break;
	 case 7 : wZERO=2048; fMAX=(float)1.25; break;
	 case 8 : wZERO=   0; fMAX=(float)10.0/2.0; break; // MAX:4096
	 case 9 : wZERO=   0; fMAX=(float)5.0/2.0;  break; // MAX:4096
	 case 10: wZERO=   0; fMAX=(float)2.5/2.0;  break; // MAX:4096
	 case 11: wZERO=   0; fMAX=(float)1.25/2.0; break; // MAX:4096

	 case 0x10 : wZERO=2048; fMAX=(float)5.0;  break;
	 case 0x11 : wZERO=2048; fMAX=(float)0.5;  break;
	 case 0x12 : wZERO=2048; fMAX=(float)0.05; break;
	 case 0x13 : wZERO=2048; fMAX=(float)0.005; break;
	 case 0x14 : wZERO=2048; fMAX=(float)10.0; break;
	 case 0x15 : wZERO=2048; fMAX=(float)1.0;  break;
	 case 0x16 : wZERO=2048; fMAX=(float)0.1;  break;
	 case 0x17 : wZERO=2048; fMAX=(float)0.01; break;
	 case 0x18 : wZERO=   0; fMAX=(float)(10.0/2.0); break; // MAX:4096
	 case 0x19 : wZERO=   0; fMAX=(float)(1.0/2.0);  break; // MAX:4096
	 case 0x1A : wZERO=   0; fMAX=(float)(0.1/2.0);  break; // MAX:4096
	 case 0x1B : wZERO=   0; fMAX=(float)(0.01/2.0); break; // MAX:4096
	 default: wRetVal=PCIDA_CONFIG_CODE_ERROR;   return(wRetVal);
       }

       ChannelParameter[wTotalCh].wZERO=wZERO;
       ChannelParameter[wTotalCh].fMAX=fMAX;

       wConfig	= wAdConfig[i]&0x0f;
       wConfig	= wConfig << 6;
       wConfig   += i;

       wConfig+= 0xD000;	   // this is set channel config command
       dwVal=pic_control(fd, wConfig);
       if(dwVal!=0) return(dwVal);
       wTotalCh++;
     }
   }

   if (wDaFrequency!=WDaFrequency) goto compute_start;
   if (fDaAmplitude!=FDaAmplitude) goto compute_start;
   goto compute_end;

 compute_start:
   switch( wType )
   {
     case 1:	// Square Wave
       for(wI=0; wI<wDaFrequency/2; wI++)  // prepare for digit for D/A
       {
	  wPattern[wI]=4095;
       }
       for(wI=wDaFrequency/2+1; wI<wDaFrequency; wI++)	// prepare for digit for D/A
       {
	  wPattern[wI]=0;
       }

       break;
     case 2:	// Semi Square Wave
       for(wI=0; wI<wDaFrequency/2; wI++)  // prepare for digit for D/A
       {
	  wPattern[wI]=4095;
       }
       for(wI=wDaFrequency/2+1; wI<wDaFrequency; wI++)	// prepare for digit for D/A
       {
	  wPattern[wI]=2048;
       }
       break;
     default:	 // Sin Wave
       pi2=(float)(3.1415926535*2.0)/wDaFrequency;
       ff=(fDaAmplitude/10.0)*2047.0;
       f1=(float)0.0;
       for(wI=0; wI<wDaFrequency; wI++)  // prepare for digit for D/A
       {
	  f2=(float)sin(f1);
	  if (f2>=0)
	  {
	    j=(int)((f2/1.0)*ff);
	    j=0x800+j;	// 0x800=2048
	  }
	  else
	  {
	    j=(int)((f2/(-1.0)*ff));
	    j=0x800-j;	// 0x800=2048
	  }
	  f1+=pi2;
	  wPattern[wI]=j;
       }
       break;
   }

   WDaFrequency=wDaFrequency;
   FDaAmplitude=fDaAmplitude;
 compute_end:

   disable_timer0(fd);
   disable_timer1(fd);


   // STEP_3 : start_to_scan

   dwVal=pic_control(fd, 0xD400); /* 11?1 01?? ???? ???? cmd_101=start scan */
   if (dwVal!=0) return(dwVal);

   // Clear FIFO
   if (PCIDA_OutputByte(fd, IXPCI_CR, 0x2000)) return PCIDA_WRITE_CR_ERROR;
   if (PCIDA_OutputByte(fd, IXPCI_CR, 0xA000)) return PCIDA_WRITE_CR_ERROR;

   //wConfig=  wAdConfig;

   enable_timer0(fd, wAdClock); // --> start AD --> 330K
   for(wI=0; wI<wDaWave; wI++)
   {
     for(wJ=0; wJ<wDaFrequency; wJ++)
     {
       dwData=wPattern[wJ];
       if (PCIDA_OutputByte(fd, IXPCI_DA1, dwData)) return PCIDA_ANALOG_OUTPUT_ERROR;
     }
   }

   dwData=wPattern[0];     // return to start
   if (PCIDA_OutputByte(fd, IXPCI_DA1, dwData)) return PCIDA_ANALOG_OUTPUT_ERROR;

   disable_timer0(fd); // --> stop AD

   // delay for settling time
   for (i=0; i<wTotalCh; i++)
   {
     dwTime=0;
     for (;;)
     {
        dwVal = PCIDA_InputByte(fd, IXPCI_SR);
        if ( dwVal == FAILURE ) return PCIDA_READ_SR_ERROR;
        dwVal = dwVal & 0x20;

        if (dwVal!=0) break;

        dwTime++;
        if (dwTime>100000) { return( PCIDA_CR_TIME_OUT ); }
     }
     //_inpw(wAddrAdda)&0xffff;
     PCIDA_InputByte(fd, IXPCI_AD);
   }

   fAdMin=(float)10.0;
   fAdMax=(float)-10.0;
   for (i=0; i<wAdNumber; i++)
   {
     for(j=0,dwIndex=0; j<wTotalCh; j++,dwIndex+=(DWORD)wAdNumber)
     {
       ad_data = PCIDA_InputByte(fd, IXPCI_AD);
       if ( ad_data == FAILURE ) return PCIDA_ANALOG_INPUT_ERROR;
       fVal=(float)((((float)(ad_data&0x0fff)-ChannelParameter[j].wZERO)/2048.0)*ChannelParameter[j].fMAX);
       if(fVal<fAdMin) fAdMin=fVal;
       if(fVal>fAdMax) fAdMax=fVal;
       // dfAdBuf[j*dwAdNumber+i]=dfVal;
       fAdBuf[dwIndex+i]=fVal;
     }
   }

   if(fAdMin<fLowAlarm)  wRetVal=PCIDA_LOW_ALARM;
   if(fAdMax>fHighAlarm) wRetVal=PCIDA_HIGH_ALARM;
   return(wRetVal);
}

WORD PCI_180X_StartScanPostTrg(WORD fd, WORD wSampleRateDiv, DWORD dwNum, int nPriority)
{
  WORD wVal,i,j;
  pthread_attr_t attr;
  struct sched_param param;
  int err;

  wIntTrig=0; /* not internal trriggerr */

  dwMagicNum=dwNum;
  disable_timer0(fd);
  disable_timer1(fd);

  wVal=pic_control(fd, 0xD400); /* 11?1 01?? ???? ???? cmd_101=start scan */
  if (wVal != PCIDA_NOERROR) return wVal;

  // 1. disable all external trigger
  if (PCIDA_OutputByte(fd, IXPCI_CR, 0xf000)) return PCIDA_WRITE_CR_ERROR;

  // 2. Sampling rate=8M/dwSampleRateDiv
  enable_timer1(fd, wSampleRateDiv); 

  // 3, B15=0,S2=1,S1=S0=0 --> clr FIFO
  if (PCIDA_OutputByte(fd, IXPCI_CR, 0x7000)) return PCIDA_WRITE_CR_ERROR;

  // 3. B15=1,S2=1,S1=S0=0 --> no clr FIFO
  if (PCIDA_OutputByte(fd, IXPCI_CR, 0xf000)) return PCIDA_WRITE_CR_ERROR;

  // 4. S2=1, S1=1, S0=1   --> wait ext signal
  //    to enable timer-1
  if (PCIDA_OutputByte(fd, IXPCI_CR, 0xfc00)) return PCIDA_WRITE_CR_ERROR;

  // create magicscan thread
  pthread_mutex_init(&lock, NULL); //init mutex object
  pthread_attr_init(&attr);
  bzero(&param, sizeof(param));
  param.__sched_priority = nPriority;
  pthread_attr_setschedparam(&attr, &param);
  wThreadStatus=0; wAskThreadStop=0;
  err = pthread_create(&hThread, &attr, magic_scan, &fd);


  if (err!=0)
  {
    pthread_mutex_destroy(&lock);
    return PCIDA_CREATE_SCAN_THREAD_ERROR;
  }
  else
  {
    i=0;
    for(;;)
    {
      pthread_mutex_lock(&lock);
      j=wThreadStatus;
      pthread_mutex_unlock(&lock);
      if (j!=0) break;
      i++;
      sleep(1);
      if (i>1000)
      {
        pthread_join(hThread, NULL);
        pthread_mutex_destroy(&lock);
        return PCIDA_MAGIC_SCAN_THREAD_ERROR;
      }
    }
  }

  return PCIDA_NOERROR;
}

void *magic_scan_pre_mid_trg(void *arg)
{
  WORD fd = *(WORD *)arg;
  WORD wI,wMid;
  DWORD dwVal;
  DWORD i,j,k,dwMiddle;

  for (j=0; j<wMP; j++) dwMagicSum[j]=0;
  for (j=0; j<wMP; j++) wMagicNow[j]=wMagicAve[j];
  for (j=0; j<wMP; j++) dwMagicP[j]=0;
  dwMagicLowAlarm=0;
  dwMagicHighAlarm=0;

  pthread_mutex_lock(&lock);
  wThreadStatus = 0x01;
  pthread_mutex_unlock(&lock);

  i=0; wMid=0; dwMiddle=0;
  for (;;)
  {
    for (j=0; j<wMP; j++)
    {
      k=0;
      for (;;)
      {
        k++;
        if (k >= 99)
        {
          k=0;
          if (wPreMid==0)
 	  {
            dwVal = PCIDA_InputByte(fd, IXPCI_SR);
            dwVal=dwVal&0x08;
	    if (dwVal != 0) goto ret_ok;
	  }

          pthread_mutex_lock(&lock);
          if (wAskThreadStop != 0)  // Force to quit this thread
 	  {
  	    wThreadStatus=0x40;
	    pthread_mutex_unlock(&lock);
	    goto ret_label;
	  }
	  pthread_mutex_unlock(&lock);
	}

        dwVal = PCIDA_InputByte(fd, IXPCI_SR);
        dwVal=dwVal&0x60;
	if (dwVal==0x20)
	{
          pthread_mutex_lock(&lock);
	  wThreadStatus=8;   // FIFO OVERFLOW
          pthread_mutex_unlock(&lock);
	  goto ret_label;
	}
	
        if (dwVal==0x60) break;
      }

      dwVal = PCIDA_InputByte(fd, IXPCI_AD);
      dwVal=dwVal&0x0fff;
      if (wMagicScanSave[j]==1) *((wMagicScanBuf[j])+i)=dwVal;
    }

    i++;
    if (i>=dwMagicNum) i=0;
    if (wPreMid==1)
    {
      dwVal = PCIDA_InputByte(fd, IXPCI_SR);
      dwVal=dwVal&0x08;
      if (dwVal != 0)
      {
        if ((dwMiddle++)> dwMagicN2) goto ret_ok;;
      }
    }
  }

ret_ok:

  i++;
  wI=(WORD)i;
  if (wI>=dwMagicNum) wI=0;

  for (j=0; j<wMP; j++)
  {
    if (wMagicScanSave[j]==1)
    {
      k=wI;
      for (i=0; i<dwMagicNum; i++)
      {
        wPattern[i]=*((wMagicScanBuf[j])+k);
        k++; if (k>=dwMagicNum) k=0;
      }

      for (i=0; i<dwMagicNum; i++) *((wMagicScanBuf[j])+i)=wPattern[i];
    }
  }

  pthread_mutex_lock(&lock);
  wThreadStatus=0x80;   // MagicScan OK
  pthread_mutex_unlock(&lock);
  ret_label:
  disable_timer0(fd);
  disable_timer1(fd);
  pthread_exit(0);
}

WORD PCI_180X_StartScanPreTrg(WORD fd, WORD wSampleRateDiv, DWORD dwNum, int nPriority)
{
  WORD wVal,i,j;
  pthread_attr_t attr;
  struct sched_param param;
  int err;

  dwMagicNum=dwNum;
  disable_timer0(fd);
  disable_timer1(fd);

  wVal=pic_control(fd, 0xD400); /* 11?1 01?? ???? ???? cmd_101=start scan */
  if (wVal != PCIDA_NOERROR) return wVal;

  // 1. disable all external trigger
  if (PCIDA_OutputByte(fd, IXPCI_CR, 0xf000)) return PCIDA_WRITE_CR_ERROR;

  // 2. Sampling rate=8M/dwSampleRateDiv
  enable_timer1(fd, wSampleRateDiv);

  // 3, B15=0,S2=1,S1=S0=0 --> clr FIFO
  if (PCIDA_OutputByte(fd, IXPCI_CR, 0x6800)) return PCIDA_WRITE_CR_ERROR;

  // 3. B15=1,S2=1,S1=S0=0 --> no clr FIFO
  if (PCIDA_OutputByte(fd, IXPCI_CR, 0xE800)) return PCIDA_WRITE_CR_ERROR;

  // 4. S2=1, S1=1, S0=1   --> wait ext signal
  //    to diable timer-1
  if (PCIDA_OutputByte(fd, IXPCI_CR, 0xF800)) return PCIDA_WRITE_CR_ERROR;

  // create magicscan thread
  pthread_mutex_init(&lock, NULL); //init mutex object
  pthread_attr_init(&attr);
  bzero(&param, sizeof(param));
  param.__sched_priority = nPriority;
  pthread_attr_setschedparam(&attr, &param);
  wThreadStatus=0; wPreMid=0; wAskThreadStop=0;
  err = pthread_create(&hThread, &attr, magic_scan_pre_mid_trg, &fd);

  if (err!=0)
  {
    pthread_mutex_destroy(&lock);
    return PCIDA_CREATE_SCAN_THREAD_ERROR;
  }
  else
  {
    i=0;
    for(;;)
    {
      pthread_mutex_lock(&lock);
      j=wThreadStatus;
      pthread_mutex_unlock(&lock);
      if (j!=0) break;
      i++;
      sleep(1);
      if (i>1000)
      {
        pthread_join(hThread, NULL);
        pthread_mutex_destroy(&lock);
        return PCIDA_MAGIC_SCAN_THREAD_ERROR;
      }
    }
  }

  return PCIDA_NOERROR;
}

WORD PCI_180X_StartScanMiddleTrg(WORD fd, WORD wSampleRateDiv, DWORD dwN1, DWORD dwN2, int nPriority)
{
  WORD wVal,i,j;
  pthread_attr_t attr;
  struct sched_param param;
  int err;

  dwMagicNum=dwN1;
  dwMagicN2 =dwN2;

  disable_timer0(fd);
  disable_timer1(fd);

  wVal=pic_control(fd, 0xD400); /* 11?1 01?? ???? ???? cmd_101=start scan */
  if (wVal != PCIDA_NOERROR) return wVal;

  // 1. disable all external trigger
  if (PCIDA_OutputByte(fd, IXPCI_CR, 0xf000)) return PCIDA_WRITE_CR_ERROR;

  // 2. Sampling rate=8M/dwSampleRateDiv
  enable_timer1(fd, wSampleRateDiv);

  // 3, B15=0,S2=1,S1=S0=0 --> clr FIFO
  if (PCIDA_OutputByte(fd, IXPCI_CR, 0x6800)) return PCIDA_WRITE_CR_ERROR;

  // 3. B15=1,S2=1,S1=S0=0 --> no clr FIFO
  if (PCIDA_OutputByte(fd, IXPCI_CR, 0xE800)) return PCIDA_WRITE_CR_ERROR;

  // 4. S2=1, S1=1, S0=1   --> wait ext signal
  //    to diable timer-1
  if (PCIDA_OutputByte(fd, IXPCI_CR, 0xFC00)) return PCIDA_WRITE_CR_ERROR;

// create magicscan thread
  // create magicscan thread
  pthread_mutex_init(&lock, NULL); //init mutex object
  pthread_attr_init(&attr);
  bzero(&param, sizeof(param));
  param.__sched_priority = nPriority;
  pthread_attr_setschedparam(&attr, &param);
  wThreadStatus=0; wPreMid=1; wAskThreadStop=0;
  err = pthread_create(&hThread, &attr, magic_scan_pre_mid_trg, &fd);

  if (err!=0)
  {
    pthread_mutex_destroy(&lock);
    return PCIDA_CREATE_SCAN_THREAD_ERROR;
  }
  else
  {
    i=0;
    for(;;)
    {
      pthread_mutex_lock(&lock);
      j=wThreadStatus;
      pthread_mutex_unlock(&lock);
      if (j!=0) break;
      i++;
      sleep(1);
      if (i>1000)
      {
        pthread_join(hThread, NULL);
        pthread_mutex_destroy(&lock);
        return PCIDA_MAGIC_SCAN_THREAD_ERROR;
      }
    }
  }

  return PCIDA_NOERROR;
}

void *magic_scan_pre_mid_trg_ver_c(void *arg)
{
  WORD fd = *(WORD *)arg;
  WORD wMid,wOld;
  DWORD i,j,k,dwMiddle,dwT;
  DWORD dwVal;

  for (j=0; j<wMP; j++) dwMagicSum[j]=0;
  for (j=0; j<wMP; j++) wMagicNow[j]=wMagicAve[j];
  for (j=0; j<wMP; j++) dwMagicP[j]=0;
  dwMagicLowAlarm=0;
  dwMagicHighAlarm=0;

  pthread_mutex_lock(&lock);
  wThreadStatus = 0x01;
  pthread_mutex_unlock(&lock);

  i=0; wMid=0; dwMiddle=0; wOld=0;
  for (;;)
  {
    for (j=0; j<wMP; j++)
    {
      k=0;
      for (;;)
      {
        if ((wPreMid==1) & (wOld==0))     // middle-trigger
        {
	  dwVal = PCIDA_InputByte(fd, IXPCI_SR);
	  dwVal=dwVal&0x08;

	  if (dwVal == 0)	      // trigger signal is active
          {			      // 6. enable pacer again
            PCIDA_OutputByte(fd, IXPCI_CR, 0xEC00);
            PCIDA_OutputByte(fd, IXPCI_CR, 0xFC00);
	    wOld=1;
	  }
	}

	k++;
	if (k >= 99)
	{
	  k=0;
	  if (wPreMid==0)		      // pre-trigger
	  {
            dwVal = PCIDA_InputByte(fd, IXPCI_SR);
	    dwVal=dwVal&0x08;
	    if (dwVal == 0) goto ret_ok; // trigger signal is active
	  }

	  pthread_mutex_lock(&lock);
	  if (wAskThreadStop != 0)  // force to quit this thread
	  {
	    wThreadStatus=0x40;
            pthread_mutex_unlock(&lock);
	    goto ret_label;
	  }
          pthread_mutex_unlock(&lock);
	}

        dwVal = PCIDA_InputByte(fd, IXPCI_SR);
	dwVal=dwVal&0x60;
	if (dwVal==0x20)		// FIFO overflow ?
	{
	  pthread_mutex_lock(&lock);
	  wThreadStatus=8;   // FIFO OVERFLOW
          pthread_mutex_unlock(&lock);
	  goto ret_label;
	}
   
        if (dwVal==0x60) break;	// FIFO data ready
      }

      dwVal = PCIDA_InputByte(fd, IXPCI_AD);
      dwVal=dwVal&0x0fff;	// read data from FIFO
      if (wMagicScanSave[j]==1) *((wMagicScanBuf[j])+i)=dwVal;
    }

    i++;
    if (i>=dwMagicNum) i=0;
    if ((wPreMid==1) && (wOld==1)) // 7. read the last N2 data of middle-trg
    {
      if ((dwMiddle++)> dwMagicN2) goto ret_ok;;
    }
  }

ret_ok:

  dwT=i++;
  if (dwT>=dwMagicNum) dwT=0;

  for (j=0; j<wMP; j++)		// adjust circule-buffer to linear array
  {
    if (wMagicScanSave[j]==1)
    {
      k=dwT;
      for (i=0; i<dwMagicNum; i++)
      {
        wPattern[i]=*((wMagicScanBuf[j])+k);
        k++; if (k>=dwMagicNum) k=0;
      }

      for (i=0; i<dwMagicNum; i++) *((wMagicScanBuf[j])+i)=wPattern[i];
    }
  }

  pthread_mutex_lock(&lock);
  wThreadStatus=0x80;	       // OK
  pthread_mutex_unlock(&lock);
  ret_label:
  disable_timer0(fd);
  disable_timer1(fd);
  pthread_exit(0);
}



WORD PCI_180X_StartScanPreTrgVerC(WORD fd, WORD wSampleRateDiv, DWORD dwN1, int nPriority)
{
  WORD  wVal,i,j;

  pthread_attr_t attr;
  struct sched_param param;
  int err;

  dwMagicNum=dwN1;

  disable_timer0(fd);
  disable_timer1(fd);

  wVal=pic_control(fd, 0xD400); /* 11?1 01?? ???? ???? cmd_101=start scan */
  if (wVal != PCIDA_NOERROR) return wVal;

   // 1. disable all external trigger
  if (PCIDA_OutputByte(fd, IXPCI_CR, 0xf000)) return PCIDA_WRITE_CR_ERROR;

  // 2. Sampling rate=8M/dwSampleRateDiv
  enable_timer1(fd, wSampleRateDiv);

  // 3, B15=0,S2=1,S1=S0=0 --> clr FIFO
  if (PCIDA_OutputByte(fd, IXPCI_CR, 0x6800)) return PCIDA_WRITE_CR_ERROR;

  // 3. B15=1,S2=1,S1=S0=0 --> no clr FIFO
  if (PCIDA_OutputByte(fd, IXPCI_CR, 0xE800)) return PCIDA_WRITE_CR_ERROR;

  // 4. S2=1, S1=1, S0=1   --> wait ext signal
  //    to diable timer-1
  if (PCIDA_OutputByte(fd, IXPCI_CR, 0xF800)) return PCIDA_WRITE_CR_ERROR;

  pthread_mutex_init(&lock, NULL); //init mutex object
  pthread_attr_init(&attr);
  bzero(&param, sizeof(param));
  param.__sched_priority = nPriority;
  pthread_attr_setschedparam(&attr, &param);
  wThreadStatus=0; wPreMid=0; wAskThreadStop=0;
  err = pthread_create(&hThread, &attr, magic_scan_pre_mid_trg_ver_c, &fd);

  if (err!=0)
  {
    pthread_mutex_destroy(&lock);
    return PCIDA_CREATE_SCAN_THREAD_ERROR;
  }
  else
  {
    i=0;
    for(;;)
    {
      pthread_mutex_lock(&lock);
      j=wThreadStatus;
      pthread_mutex_unlock(&lock);
      if (j!=0) break;
      i++;
      sleep(1);
      if (i>1000)
      {
        pthread_join(hThread, NULL);
        pthread_mutex_destroy(&lock);
        return PCIDA_MAGIC_SCAN_THREAD_ERROR;
      }
    }
  }

  return PCIDA_NOERROR;
}

WORD PCI_180X_StartScanMiddleTrgVerC(WORD fd, WORD wSampleRateDiv, DWORD dwN1, DWORD dwN2, int nPriority)
{
  WORD wVal,i,j;
  pthread_attr_t attr;
  struct sched_param param;
  int err;

  dwMagicNum=dwN1;
  dwMagicN2 =dwN2;

  disable_timer0(fd);
  disable_timer1(fd);

  wVal=pic_control(fd, 0xD400); /* 11?1 01?? ???? ???? cmd_101=start scan */
  if (wVal != PCIDA_NOERROR) return wVal;

   // 1. disable all external trigger
  if (PCIDA_OutputByte(fd, IXPCI_CR, 0xf000)) return PCIDA_WRITE_CR_ERROR;

  // 2. Sampling rate=8M/dwSampleRateDiv
  enable_timer1(fd, wSampleRateDiv);

  // 3, B15=0,S2=1,S1=S0=0 --> clr FIFO
  if (PCIDA_OutputByte(fd, IXPCI_CR, 0x6800)) return PCIDA_WRITE_CR_ERROR;

  // 3. B15=1,S2=1,S1=S0=0 --> enable timer-1
  if (PCIDA_OutputByte(fd, IXPCI_CR, 0xE800)) return PCIDA_WRITE_CR_ERROR;

  // 4. S2=1, S1=1, S0=1   --> wait ext signal
  //    to diable timer-1
  if (PCIDA_OutputByte(fd, IXPCI_CR, 0xF800)) return PCIDA_WRITE_CR_ERROR;

  // create magicscan thread
  pthread_mutex_init(&lock, NULL); //init mutex object
  pthread_attr_init(&attr);
  bzero(&param, sizeof(param));
  param.__sched_priority = nPriority;
  pthread_attr_setschedparam(&attr, &param);
  wThreadStatus=0; wPreMid=1; wAskThreadStop=0;
  err = pthread_create(&hThread, &attr, magic_scan_pre_mid_trg_ver_c, &fd);

  if (err!=0)
  {
    pthread_mutex_destroy(&lock);
    return PCIDA_CREATE_SCAN_THREAD_ERROR;
  }
  else
  {
    i=0;
    for(;;)
    {
      pthread_mutex_lock(&lock);
      j=wThreadStatus;
      pthread_mutex_unlock(&lock);
      if (j!=0) break;
      i++;
      sleep(1);
      if (i>1000)
      {
        pthread_join(hThread, NULL);
        pthread_mutex_destroy(&lock);
        return PCIDA_MAGIC_SCAN_THREAD_ERROR;
      }
    }
  }

  return PCIDA_NOERROR;
}

WORD wait_until_pic_ok(WORD fd)
{
  WORD j;
  DWORD sr_value;
  j=0;
  for (;;)
  {
    sr_value = PCIDA_InputByte(fd, IXPCI_SR);
    if ( sr_value == FAILURE ) return PCIDA_READ_SR_ERROR;
    sr_value = sr_value & 0x04;

    if (sr_value!=0) return(0);    /* PIC OK */
    j++;
    if (j>32760) return(1); /* time out */
  }

  return SUCCESS;
}

