/* PCI Linux Static Library.

   Author: Golden Wang

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

/* File level history (record changes for this file here.)

   Use vi or gvim to edit this file and set tabstop=4.

   v 0.1.0  1 Apr 2008 by Golde Wang
     give support to pci1800.  

   v 0.0.0  1 Apr 2008 by Golden Wang
     create, blah blah.
    	
*/

/* the header that defined all variable and funtions */ 
#include "pcidio.h"
/* defined private function here */
WORD PCIDA_Init(WORD fd);
WORD PCIDA_GetDeviceModuleName(void);

//dev_control_t *dev_ctl;

char device_module[256];
char device_file[LINE_SIZE];
char ixpci[MAX_CARD_SUPPORT][LINE_SIZE];

/* open ixpio device file */
int PCIDA_Open(char *dev_file)
{
	int fd;

	strcpy(device_file, dev_file); 
	fd = open(dev_file, O_RDWR);
	return fd;
}

/* close ixpio device file */
WORD PCIDA_Close(WORD fd)
{
	/* free malloc memory */
	//if ( dev_ctl ) free(dev_ctl);

	/* close device file */
	close(fd);
	return PCIDA_NOERROR;
}

WORD PCIDA_DriverInit(WORD fd)
{
	if(PCIDA_GetDeviceModuleName()) 
		return PCIDA_MODULE_NAME_GET_ERROR;

	PCIDA_Init(fd);

	return PCIDA_NOERROR;
}

WORD PCIDA_Init(WORD fd)
{
	if (!strcmp(device_module,"ixpcilanner"))
        {
		Get_Lanner_Gain_Offset(fd);
        }

	return PCIDA_NOERROR;
}

/* get ixpio device module name */  
WORD PCIDA_GetDeviceModuleName()
{
	FILE *fd_proc;
	char rbuf[254];
	char *module;
	int module_num = 0;
	int module_index = 0;

	fd_proc = fopen(IXPCI_PROC_FILE, "r");
 
	if (!fd_proc) return FAILURE;
 
	while (fgets(rbuf, 254, fd_proc))
	{
		if (!strncmp(rbuf, "mod:", 4))
		{
			module = strtok(strtok(rbuf + 4, "\n"), " ");

			while(module != NULL)
			{
				strcpy(ixpci[module_num],module);
				module = strtok(NULL," ");
				module_num++;
			}
		}

		if (!strncmp(rbuf, "dev:", 4))
		{
			if(strstr(rbuf,strtok(device_file + 4, "/")))
			{
				break;
			}
      
			module_index++;
		}
	}

	fclose(fd_proc);

	strcpy(device_module, ixpci[module_index]);
 
	return PCIDA_NOERROR;
}

/* get ixpio device driver version that be defined in piodio.h */ 
char* PCIDA_GetDriverVersion(void)
{
	//printf("Drive VERSION %s\n",IXPCI_DRIVER_VERSION);
	return IXPCI_DRIVER_VERSION;
}

char* PCIDA_GetLibraryVersion(void)
{
	//printf("Library VERSION %s\n",IXPCI_LIBRARY_VERSION);
	return IXPCI_LIBRARY_VERSION;
}

WORD PCIDA_OutputByte(WORD fd, DWORD reg_id, DWORD reg_value)
{
        ixpci_reg_t reg;

        reg.id = reg_id;
        reg.value = reg_value;

        if (ioctl(fd, IXPCI_WRITE_REG, &reg))
        {
                close(fd);
                return FAILURE;
        }

        return PCIDA_NOERROR;
}

DWORD PCIDA_InputByte(WORD fd, DWORD reg_id)
{
        ixpci_reg_t reg;

        reg.id = reg_id;
        reg.value = 0;

        if (ioctl(fd, IXPCI_READ_REG, &reg))
        {
                close(fd);
                return FAILURE;
        }

        return reg.value;
}

/*
WORD PCIDA_OutputByte(WORD fd, ixpci_reg_t *p_reg)
{
   if (ioctl(fd, IXPCI_WRITE_REG, p_reg))
   {
     close(fd);
     return FAILURE;
   }

   return PCIDA_NOERROR;
}

WORD PCIDA_InputByte(WORD fd, ixpci_reg_t *p_reg)
{
  if (ioctl(fd, IXPCI_READ_REG, p_reg))
  {
    close(fd);
    return FAILURE;
  }

  return PCIDA_NOERROR;
}
*/

